
;**************************************************************************
;*              AMS Display Driver 1 (SW) - Example / Demo                *
;**************************************************************************
;**************************************************************************
;*                                                                        *
;*          v 1.08 - 15.08.2015                                           *
;*                                                                        *
;**************************************************************************
;*          Hardw.: PIC16F627A used                                       *
;**************************************************************************


 INCLUDE "P16F628A.INC"


	__CONFIG        _BODEN_OFF & _CP_OFF & DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT


;==========================================================================
;       Variable Definition
;==========================================================================
TIMER1		EQU	H'20'		;delay routine
TIMER2		EQU	H'21'		; "	"	"
TIMER3		EQU	H'22'		;delay routine

v_intensity	EQU	H'23'
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------


;==========================================================================

		ORG	0		;Reset vector address
		goto	RESET

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


;	       **********************************
;              **  RESET :  main boot routine  **
;              **********************************

RESET		MOVLW	B'00000111'	;Disable Comparator module's
		MOVWF	CMCON
		;
		BSF	STATUS,RP0	;Switch to register bank 1
					;Disable pull-ups
					;INT on rising edge
					;TMR0 to CLKOUT
					;TMR0 Incr low2high trans.
					;Prescaler assign to Timer0
					;Prescaler rate is 1:256
		MOVLW	B'11010111'	;Set PIC options (See datasheet).
		MOVWF	OPTION_REG	;Write the OPTION register.
		;
		CLRF	INTCON		;Disable interrupts
		MOVLW	B'00000000'
		MOVWF	TRISB		;RBx
		MOVLW	B'00110000'	;RA4 & RA5 - input
		MOVWF	TRISA
		BCF	STATUS,RP0	;Switch Back to reg. Bank 0

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------

		call	AMS_init

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
start_up	nop

		call	AMS_test
		call	dr2
		call	dr2
		call	dr2
		call	AMS_test_off

;--------------------------------------------------

main_loop	nop

		call	demo1
		call	demo2
		call	demo3

		goto	main_loop

;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo1		movlw	' '
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		movwf	ams_v_dig4
		movwf	ams_v_dig5
		movwf	ams_v_dig6
		movwf	ams_v_dig7

		movlw	'0'
		movwf	ams_v_dig0
		call	AMS_disp_code
		call	dr2

		movlw	'1'
		movwf	ams_v_dig1
		call	AMS_disp_code
		call	dr2

		movlw	'2'
		movwf	ams_v_dig2
		call	AMS_disp_code
		call	dr2

		movlw	'3'
		movwf	ams_v_dig3
		call	AMS_disp_code
		call	dr2

		movlw	'4'
		movwf	ams_v_dig4
		call	AMS_disp_code
		call	dr2

		movlw	'5'
		movwf	ams_v_dig5
		call	AMS_disp_code
		call	dr2

		movlw	'6'
		movwf	ams_v_dig6
		call	AMS_disp_code
		call	dr2

		movlw	'7'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2
		call	dr2
		call	dr2

		movlw	'7'
		movwf	ams_v_dig0
		movlw	'6'
		movwf	ams_v_dig1
		movlw	'5'
		movwf	ams_v_dig2
		movlw	'4'
		movwf	ams_v_dig3
		movlw	'3'
		movwf	ams_v_dig4
		movlw	'2'
		movwf	ams_v_dig5
		movlw	'1'
		movwf	ams_v_dig6
		movlw	'0'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2
		call	dr2
		call	dr2

		return


;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo2		movlw	'0'
		movwf	ams_v_dig0
		movlw	'1'
		movwf	ams_v_dig1
		movlw	'2'
		movwf	ams_v_dig2
		movlw	'3'
		movwf	ams_v_dig3
		movlw	'4'
		movwf	ams_v_dig4
		movlw	'5'
		movwf	ams_v_dig5
		movlw	'6'
		movwf	ams_v_dig6
		movlw	'7'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2

		movlw	H'00'
		movwf	v_intensity

demo2_loop	movf	v_intensity,0
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		bcf	ams_v_dig0,D'004'
		bcf	ams_v_dig1,D'004'
		bcf	ams_v_dig2,D'004'
		bcf	ams_v_dig3,D'004'

		call	AMS_intensity
		call	AMS_disp_code

		call	dr2
		call	dr2

		incf	v_intensity,1
		btfss	v_intensity,D'004'
		goto	demo2_loop

		movlw	H'0F'
		call	AMS_intensity

		return
;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo3		movlw	' '
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		movwf	ams_v_dig4
		movwf	ams_v_dig5
		movwf	ams_v_dig6
		movwf	ams_v_dig7

		movlw	'0'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig7
		movlw	'1'
		movwf	ams_v_dig6
		call	AMS_disp_code
		call	dr2
		
		movlw	' '
		movwf	ams_v_dig6
		movlw	'2'
		movwf	ams_v_dig5
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig5
		movlw	'3'
		movwf	ams_v_dig4
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig4
		movlw	'4'
		movwf	ams_v_dig3
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig3
		movlw	'5'
		movwf	ams_v_dig2
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig2
		movlw	'6'
		movwf	ams_v_dig1
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig1
		movlw	'7'
		movwf	ams_v_dig0
		call	AMS_disp_code
		call	dr2

		return
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;--------------------------------------------------------------------

;		*********************************************
;		*               delay routine               *
;		*********************************************

;------------------------------------

d2		movlw	D'255'
		movwf	TIMER2
DEL_LOOP1	movlw	D'255'
		movwf	TIMER1

DEL_LOOP2	decfsz	TIMER1,F
		goto	DEL_LOOP2
		decfsz	TIMER2,F
		goto	DEL_LOOP1
		return
;------------------------------------
dr2		call	d2
		call	d2
		return
;------------------------------------
dr6		call	dr2
		call	dr2
		return
;-----------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------

	INCLUDE "AMS_DDriver_SW2_SPI_v1p09.inc"

		END